Agora Java API Reference for Android

Static Public Member Functions | Public Attributes | List of all members
io.agora.rtm.RtmConstants.RtmErrorCode Enum Reference

## Static Public Member Functions
| [static initializer]
static int | getValue (RtmErrorCode code)
static RtmErrorCode | getEnum (Integer value)

## Public Attributes
| OK =(0)
| NOT_INITIALIZED =(-10001)
| NOT_LOGIN =(-10002)
| INVALID_APP_ID =(-10003)
| INVALID_EVENT_HANDLER =(-10004)
| INVALID_TOKEN =(-10005)
| INVALID_USER_ID =(-10006)
| INIT_SERVICE_FAILED =(-10007)
| INVALID_CHANNEL_NAME =(-10008)
| TOKEN_EXPIRED =(-10009)
| LOGIN_NO_SERVER_RESOURCES =(-10010)
| LOGIN_TIMEOUT =(-10011)
| LOGIN_REJECTED =(-10012)
| LOGIN_ABORTED =(-10013)
| INVALID_PARAMETER =(-10014)
| LOGIN_NOT_AUTHORIZED =(-10015)
| INCONSISTENT_APPID =(-10016)
| DUPLICATE_OPERATION =(-10017)
| INSTANCE_ALREADY_RELEASED =(-10018)
| INVALID_CHANNEL_TYPE =(-10019)
| INVALID_ENCRYPTION_PARAMETER =(-10020)
| OPERATION_RATE_EXCEED_LIMITATION =(-10021)
| SERVICE_NOT_SUPPORTED =(-10022)
| LOGIN_CANCELED =(-10023)
| INVALID_PRIVATE_CONFIG =(-10024)
| NOT_CONNECTED =(-10025)
| RENEW_TOKEN_TIMEOUT =(-10026)
| DUPLICATE_USER_ID =(-10027)
| CHANNEL_NOT_JOINED =(-11001)
| CHANNEL_NOT_SUBSCRIBED =(-11002)
| CHANNEL_EXCEED_TOPIC_USER_LIMITATION =(-11003)
| CHANNEL_IN_REUSE =(-11004)
| CHANNEL_INSTANCE_EXCEED_LIMITATION =(-11005)
| CHANNEL_IN_ERROR_STATE =(-11006)
| CHANNEL_JOIN_FAILED =(-11007)
| CHANNEL_INVALID_TOPIC_NAME =(-11008)
| CHANNEL_INVALID_MESSAGE =(-11009)
| CHANNEL_MESSAGE_LENGTH_EXCEED_LIMITATION =(-11010)
| CHANNEL_INVALID_USER_LIST =(-11011)
| CHANNEL_NOT_AVAILABLE =(-11012)
| CHANNEL_TOPIC_NOT_SUBSCRIBED =(-11013)
| CHANNEL_EXCEED_TOPIC_LIMITATION =(-11014)
| CHANNEL_JOIN_TOPIC_FAILED =(-11015)
| CHANNEL_TOPIC_NOT_JOINED =(-11016)
| CHANNEL_TOPIC_NOT_EXIST =(-11017)
| CHANNEL_INVALID_TOPIC_META =(-11018)
| CHANNEL_SUBSCRIBE_TIMEOUT =(-11019)
| CHANNEL_SUBSCRIBE_TOO_FREQUENT =(-11020)
| CHANNEL_SUBSCRIBE_FAILED =(-11021)
| CHANNEL_UNSUBSCRIBE_FAILED =(-11022)
| CHANNEL_ENCRYPT_MESSAGE_FAILED =(-11023)
| CHANNEL_PUBLISH_MESSAGE_FAILED =(-11024)
| CHANNEL_PUBLISH_MESSAGE_TOO_FREQUENT =(-11025)
| CHANNEL_PUBLISH_MESSAGE_TIMEOUT =(-11026)
| CHANNEL_NOT_CONNECTED =(-11027)
| CHANNEL_LEAVE_FAILED =(-11028)
| CHANNEL_CUSTOM_TYPE_LENGTH_OVERFLOW =(-11029)
| CHANNEL_INVALID_CUSTOM_TYPE =(-11030)
| CHANNEL_UNSUPPORTED_MESSAGE_TYPE =(-11031)
| CHANNEL_PRESENCE_NOT_READY =(-11032)
| CHANNEL_RECEIVER_OFFLINE =(-11033)
| CHANNEL_JOIN_CANCELED =(-11034)
| CHANNEL_RECEIVER_OFFLINE_BUT_STORE_SUCCEEDED =(-11035)
| CHANNEL_RECEIVER_OFFLINE_AND_STORE_FAILED =(-11036)
| CHANNEL_MESSAGE_DELIVERED_BUT_STORE_FAILED =(-11037)
| CHANNEL_SUBSCRIBE_PERMISSION_DENIED =(-11038)
| CHANNEL_PUBLISH_PERMISSION_DENIED =(-11039)
| CHANNEL_SUBSCRIBE_CANCELED =(-11040)
| STORAGE_OPERATION_FAILED =(-12001)
| STORAGE_METADATA_ITEM_EXCEED_LIMITATION =(-12002)
| STORAGE_INVALID_METADATA_ITEM =(-12003)
| STORAGE_INVALID_ARGUMENT =(-12004)
| STORAGE_INVALID_REVISION =(-12005)
| STORAGE_METADATA_LENGTH_OVERFLOW =(-12006)
| STORAGE_INVALID_LOCK_NAME =(-12007)
| STORAGE_LOCK_NOT_ACQUIRED =(-12008)
| STORAGE_INVALID_KEY =(-12009)
| STORAGE_INVALID_VALUE =(-12010)
| STORAGE_KEY_LENGTH_OVERFLOW =(-12011)
| STORAGE_VALUE_LENGTH_OVERFLOW =(-12012)
| STORAGE_DUPLICATE_KEY =(-12013)
| STORAGE_OUTDATED_REVISION =(-12014)
| STORAGE_NOT_SUBSCRIBE =(-12015)
| STORAGE_INVALID_METADATA_INSTANCE =(-12016)
| STORAGE_SUBSCRIBE_USER_EXCEED_LIMITATION =(-12017)
| STORAGE_OPERATION_TIMEOUT =(-12018)
| STORAGE_NOT_AVAILABLE =(-12019)
| STORAGE_PERMISSION_DENIED =(-12020)
| PRESENCE_NOT_CONNECTED =(-13001)
| PRESENCE_NOT_WRITABLE =(-13002)
| PRESENCE_INVALID_ARGUMENT =(-13003)
| PRESENCE_CACHED_TOO_MANY_STATES =(-13004)
| PRESENCE_STATE_COUNT_OVERFLOW =(-13005)
| PRESENCE_INVALID_STATE_KEY =(-13006)
| PRESENCE_INVALID_STATE_VALUE =(-13007)
| PRESENCE_STATE_KEY_SIZE_OVERFLOW =(-13008)
| PRESENCE_STATE_VALUE_SIZE_OVERFLOW =(-13009)
| PRESENCE_STATE_DUPLICATE_KEY =(-13010)
| PRESENCE_USER_NOT_EXIST =(-13011)
| PRESENCE_OPERATION_TIMEOUT =(-13012)
| PRESENCE_OPERATION_FAILED =(-13013)
| PRESENCE_INACTIVE =(-13014)
| PRESENCE_PENDING_REQUEST_CANCELLED =(-13015)
| PRESENCE_PENDING_REQUEST_EXCEED_LIMITATION =(-13016)
| LOCK_OPERATION_FAILED =(-14001)
| LOCK_OPERATION_TIMEOUT =(-14002)
| LOCK_OPERATION_PERFORMING =(-14003)
| LOCK_ALREADY_EXIST =(-14004)
| LOCK_INVALID_NAME =(-14005)
| LOCK_NOT_ACQUIRED =(-14006)
| LOCK_ACQUIRE_FAILED =(-14007)
| LOCK_NOT_EXIST =(-14008)
| LOCK_NOT_AVAILABLE =(-14009)
| LOCK_PERMISSION_DENIED =(-14010)
| HISTORY_OPERATION_FAILED =(-15001)
| HISTORY_INVALID_TIMESTAMP =(-15002)
| HISTORY_OPERATION_TIMEOUT =(-15003)
| HISTORY_OPERATION_NOT_PERMITTED =(-15004)
| HISTORY_NOT_AVAILABLE =(-15005)
| HISTORY_PERMISSION_DENIED =(-15006)

## Detailed Description

The error codes of rtm client.

## Member Data Documentation

## ◆ OK

io.agora.rtm.RtmConstants.RtmErrorCode.OK =(0)

0: No error occurs.

## ◆ NOT_INITIALIZED

io.agora.rtm.RtmConstants.RtmErrorCode.NOT_INITIALIZED =(-10001)

-10001 ~ -11000 : reserved for generic error. -10001: The SDK is not initialized.

## ◆ NOT_LOGIN

io.agora.rtm.RtmConstants.RtmErrorCode.NOT_LOGIN =(-10002)

-10002: The user didn't login the RTM system.

## ◆ INVALID_APP_ID

io.agora.rtm.RtmConstants.RtmErrorCode.INVALID_APP_ID =(-10003)

-10003: The app ID is invalid.

## ◆ INVALID_EVENT_HANDLER

io.agora.rtm.RtmConstants.RtmErrorCode.INVALID_EVENT_HANDLER =(-10004)

-10004: The event handler is invalid.

## ◆ INVALID_TOKEN

io.agora.rtm.RtmConstants.RtmErrorCode.INVALID_TOKEN =(-10005)

-10005: The token is invalid.

## ◆ INVALID_USER_ID

io.agora.rtm.RtmConstants.RtmErrorCode.INVALID_USER_ID =(-10006)

-10006: The user ID is invalid.

## ◆ INIT_SERVICE_FAILED

io.agora.rtm.RtmConstants.RtmErrorCode.INIT_SERVICE_FAILED =(-10007)

-10007: The service is not initialized.

## ◆ INVALID_CHANNEL_NAME

io.agora.rtm.RtmConstants.RtmErrorCode.INVALID_CHANNEL_NAME =(-10008)

-10008: The channel name is invalid.

## ◆ TOKEN_EXPIRED

io.agora.rtm.RtmConstants.RtmErrorCode.TOKEN_EXPIRED =(-10009)

-10009: The token has expired.

## ◆ LOGIN_NO_SERVER_RESOURCES

io.agora.rtm.RtmConstants.RtmErrorCode.LOGIN_NO_SERVER_RESOURCES =(-10010)

-10010: There is no server resources now.

## ◆ LOGIN_TIMEOUT

io.agora.rtm.RtmConstants.RtmErrorCode.LOGIN_TIMEOUT =(-10011)

-10011: The login timeout.

## ◆ LOGIN_REJECTED

io.agora.rtm.RtmConstants.RtmErrorCode.LOGIN_REJECTED =(-10012)

-10012: The login is rejected by server.

## ◆ LOGIN_ABORTED

io.agora.rtm.RtmConstants.RtmErrorCode.LOGIN_ABORTED =(-10013)

-10013: The login is aborted due to unrecoverable error.

## ◆ INVALID_PARAMETER

io.agora.rtm.RtmConstants.RtmErrorCode.INVALID_PARAMETER =(-10014)

-10014: The parameter is invalid.

## ◆ LOGIN_NOT_AUTHORIZED

io.agora.rtm.RtmConstants.RtmErrorCode.LOGIN_NOT_AUTHORIZED =(-10015)

-10015: The login is not authorized. Happens user login the RTM system without granted from console.

## ◆ INCONSISTENT_APPID

io.agora.rtm.RtmConstants.RtmErrorCode.INCONSISTENT_APPID =(-10016)

-10016: Try to login or join with inconsistent app ID.

## ◆ DUPLICATE_OPERATION

io.agora.rtm.RtmConstants.RtmErrorCode.DUPLICATE_OPERATION =(-10017)

-10017: Already call same request.

## ◆ INSTANCE_ALREADY_RELEASED

io.agora.rtm.RtmConstants.RtmErrorCode.INSTANCE_ALREADY_RELEASED =(-10018)

-10018: Already call destroy or release, this instance is forbidden to call any api, please create new instance.

## ◆ INVALID_CHANNEL_TYPE

io.agora.rtm.RtmConstants.RtmErrorCode.INVALID_CHANNEL_TYPE =(-10019)

-10019: Invalid channel type

## ◆ INVALID_ENCRYPTION_PARAMETER

io.agora.rtm.RtmConstants.RtmErrorCode.INVALID_ENCRYPTION_PARAMETER =(-10020)

-10020: The encryption parameter is invalid.

## ◆ OPERATION_RATE_EXCEED_LIMITATION

io.agora.rtm.RtmConstants.RtmErrorCode.OPERATION_RATE_EXCEED_LIMITATION =(-10021)

-10021: The operation is too frequent.

## ◆ SERVICE_NOT_SUPPORTED

io.agora.rtm.RtmConstants.RtmErrorCode.SERVICE_NOT_SUPPORTED =(-10022)

-10022: The service is not configured in private config mode.

## ◆ LOGIN_CANCELED

io.agora.rtm.RtmConstants.RtmErrorCode.LOGIN_CANCELED =(-10023)

-10023: This login operation stopped by a new login operation or logout operation.

## ◆ INVALID_PRIVATE_CONFIG

io.agora.rtm.RtmConstants.RtmErrorCode.INVALID_PRIVATE_CONFIG =(-10024)

-10024: The private config is invalid, set private config should both set serviceType and accessPointHosts.

## ◆ NOT_CONNECTED

io.agora.rtm.RtmConstants.RtmErrorCode.NOT_CONNECTED =(-10025)

-10025: Perform operation failed due to RTM service is not connected.

## ◆ RENEW_TOKEN_TIMEOUT

io.agora.rtm.RtmConstants.RtmErrorCode.RENEW_TOKEN_TIMEOUT =(-10026)

-10026: Renew token timeout.

## ◆ DUPLICATE_USER_ID

io.agora.rtm.RtmConstants.RtmErrorCode.DUPLICATE_USER_ID =(-10027)

-10027: The user ID is already in use by another active RTM instance.

## ◆ CHANNEL_NOT_JOINED

io.agora.rtm.RtmConstants.RtmErrorCode.CHANNEL_NOT_JOINED =(-11001)

-11001 ~ -12000 : reserved for channel error. -11001: The user has not joined the channel.

## ◆ CHANNEL_NOT_SUBSCRIBED

io.agora.rtm.RtmConstants.RtmErrorCode.CHANNEL_NOT_SUBSCRIBED =(-11002)

-11002: The user has not subscribed the channel.

## ◆ CHANNEL_EXCEED_TOPIC_USER_LIMITATION

io.agora.rtm.RtmConstants.RtmErrorCode.CHANNEL_EXCEED_TOPIC_USER_LIMITATION =(-11003)

-11003: The topic member count exceeds the limit.

## ◆ CHANNEL_IN_REUSE

io.agora.rtm.RtmConstants.RtmErrorCode.CHANNEL_IN_REUSE =(-11004)

-11004: The channel is reused in RTC.

## ◆ CHANNEL_INSTANCE_EXCEED_LIMITATION

io.agora.rtm.RtmConstants.RtmErrorCode.CHANNEL_INSTANCE_EXCEED_LIMITATION =(-11005)

-11005: The channel instance count exceeds the limit.

## ◆ CHANNEL_IN_ERROR_STATE

io.agora.rtm.RtmConstants.RtmErrorCode.CHANNEL_IN_ERROR_STATE =(-11006)

-11006: The channel is in error state.

## ◆ CHANNEL_JOIN_FAILED

io.agora.rtm.RtmConstants.RtmErrorCode.CHANNEL_JOIN_FAILED =(-11007)

-11007: The channel join failed.

## ◆ CHANNEL_INVALID_TOPIC_NAME

io.agora.rtm.RtmConstants.RtmErrorCode.CHANNEL_INVALID_TOPIC_NAME =(-11008)

-11008: The topic name is invalid.

## ◆ CHANNEL_INVALID_MESSAGE

io.agora.rtm.RtmConstants.RtmErrorCode.CHANNEL_INVALID_MESSAGE =(-11009)

-11009: The message is invalid.

## ◆ CHANNEL_MESSAGE_LENGTH_EXCEED_LIMITATION

io.agora.rtm.RtmConstants.RtmErrorCode.CHANNEL_MESSAGE_LENGTH_EXCEED_LIMITATION =(-11010)

-11010: The message length exceeds the limit.

## ◆ CHANNEL_INVALID_USER_LIST

io.agora.rtm.RtmConstants.RtmErrorCode.CHANNEL_INVALID_USER_LIST =(-11011)

-11011: The user list is invalid.

## ◆ CHANNEL_NOT_AVAILABLE

io.agora.rtm.RtmConstants.RtmErrorCode.CHANNEL_NOT_AVAILABLE =(-11012)

-11012: The stream channel is not available.

## ◆ CHANNEL_TOPIC_NOT_SUBSCRIBED

io.agora.rtm.RtmConstants.RtmErrorCode.CHANNEL_TOPIC_NOT_SUBSCRIBED =(-11013)

-11013: The topic is not subscribed.

## ◆ CHANNEL_EXCEED_TOPIC_LIMITATION

io.agora.rtm.RtmConstants.RtmErrorCode.CHANNEL_EXCEED_TOPIC_LIMITATION =(-11014)

-11014: The topic count exceeds the limit.

## ◆ CHANNEL_JOIN_TOPIC_FAILED

io.agora.rtm.RtmConstants.RtmErrorCode.CHANNEL_JOIN_TOPIC_FAILED =(-11015)

-11015: Join topic failed.

## ◆ CHANNEL_TOPIC_NOT_JOINED

io.agora.rtm.RtmConstants.RtmErrorCode.CHANNEL_TOPIC_NOT_JOINED =(-11016)

-11016: The topic is not joined.

## ◆ CHANNEL_TOPIC_NOT_EXIST

io.agora.rtm.RtmConstants.RtmErrorCode.CHANNEL_TOPIC_NOT_EXIST =(-11017)

-11017: The topic does not exist.

## ◆ CHANNEL_INVALID_TOPIC_META

io.agora.rtm.RtmConstants.RtmErrorCode.CHANNEL_INVALID_TOPIC_META =(-11018)

-11018: The topic meta is invalid.

## ◆ CHANNEL_SUBSCRIBE_TIMEOUT

io.agora.rtm.RtmConstants.RtmErrorCode.CHANNEL_SUBSCRIBE_TIMEOUT =(-11019)

-11019: Subscribe channel timeout.

## ◆ CHANNEL_SUBSCRIBE_TOO_FREQUENT

io.agora.rtm.RtmConstants.RtmErrorCode.CHANNEL_SUBSCRIBE_TOO_FREQUENT =(-11020)

-11020: Subscribe channel too frequent.

## ◆ CHANNEL_SUBSCRIBE_FAILED

io.agora.rtm.RtmConstants.RtmErrorCode.CHANNEL_SUBSCRIBE_FAILED =(-11021)

-11021: Subscribe channel failed.

## ◆ CHANNEL_UNSUBSCRIBE_FAILED

io.agora.rtm.RtmConstants.RtmErrorCode.CHANNEL_UNSUBSCRIBE_FAILED =(-11022)

-11022: Unsubscribe channel failed.

## ◆ CHANNEL_ENCRYPT_MESSAGE_FAILED

io.agora.rtm.RtmConstants.RtmErrorCode.CHANNEL_ENCRYPT_MESSAGE_FAILED =(-11023)

-11023: Encrypt message failed.

## ◆ CHANNEL_PUBLISH_MESSAGE_FAILED

io.agora.rtm.RtmConstants.RtmErrorCode.CHANNEL_PUBLISH_MESSAGE_FAILED =(-11024)

-11024: Publish message failed.

## ◆ CHANNEL_PUBLISH_MESSAGE_TOO_FREQUENT

io.agora.rtm.RtmConstants.RtmErrorCode.CHANNEL_PUBLISH_MESSAGE_TOO_FREQUENT =(-11025)

-11025: Publish message too frequent.

## ◆ CHANNEL_PUBLISH_MESSAGE_TIMEOUT

io.agora.rtm.RtmConstants.RtmErrorCode.CHANNEL_PUBLISH_MESSAGE_TIMEOUT =(-11026)

-11026: Publish message timeout.

## ◆ CHANNEL_NOT_CONNECTED

io.agora.rtm.RtmConstants.RtmErrorCode.CHANNEL_NOT_CONNECTED =(-11027)

-11027: The connection state is invalid.

## ◆ CHANNEL_LEAVE_FAILED

io.agora.rtm.RtmConstants.RtmErrorCode.CHANNEL_LEAVE_FAILED =(-11028)

-11028: Leave channel failed.

## ◆ CHANNEL_CUSTOM_TYPE_LENGTH_OVERFLOW

io.agora.rtm.RtmConstants.RtmErrorCode.CHANNEL_CUSTOM_TYPE_LENGTH_OVERFLOW =(-11029)

-11029: The custom type length exceeds the limit.

## ◆ CHANNEL_INVALID_CUSTOM_TYPE

io.agora.rtm.RtmConstants.RtmErrorCode.CHANNEL_INVALID_CUSTOM_TYPE =(-11030)

-11030: The custom type is invalid.

## ◆ CHANNEL_UNSUPPORTED_MESSAGE_TYPE

io.agora.rtm.RtmConstants.RtmErrorCode.CHANNEL_UNSUPPORTED_MESSAGE_TYPE =(-11031)

-11031: unsupported message type (in MacOS/iOS platform，message only support NSString and NSData)

## ◆ CHANNEL_PRESENCE_NOT_READY

io.agora.rtm.RtmConstants.RtmErrorCode.CHANNEL_PRESENCE_NOT_READY =(-11032)

-11032: The channel presence is not ready.

## ◆ CHANNEL_RECEIVER_OFFLINE

io.agora.rtm.RtmConstants.RtmErrorCode.CHANNEL_RECEIVER_OFFLINE =(-11033)

-11033: The destination user of publish message is offline.

## ◆ CHANNEL_JOIN_CANCELED

io.agora.rtm.RtmConstants.RtmErrorCode.CHANNEL_JOIN_CANCELED =(-11034)

-11034: The channel join operation is canceled.

## ◆ CHANNEL_RECEIVER_OFFLINE_BUT_STORE_SUCCEEDED

io.agora.rtm.RtmConstants.RtmErrorCode.CHANNEL_RECEIVER_OFFLINE_BUT_STORE_SUCCEEDED =(-11035)

-11035: The message receiver is offline but the message store in history succeeded.

## ◆ CHANNEL_RECEIVER_OFFLINE_AND_STORE_FAILED

io.agora.rtm.RtmConstants.RtmErrorCode.CHANNEL_RECEIVER_OFFLINE_AND_STORE_FAILED =(-11036)

-11036: The message receiver is offline and the message store in history failed.

## ◆ CHANNEL_MESSAGE_DELIVERED_BUT_STORE_FAILED

io.agora.rtm.RtmConstants.RtmErrorCode.CHANNEL_MESSAGE_DELIVERED_BUT_STORE_FAILED =(-11037)

-11037: The message delivered successfully but store in history failed.

## ◆ CHANNEL_SUBSCRIBE_PERMISSION_DENIED

io.agora.rtm.RtmConstants.RtmErrorCode.CHANNEL_SUBSCRIBE_PERMISSION_DENIED =(-11038)

-11038: The subscribe permission is denied.

## ◆ CHANNEL_PUBLISH_PERMISSION_DENIED

io.agora.rtm.RtmConstants.RtmErrorCode.CHANNEL_PUBLISH_PERMISSION_DENIED =(-11039)

-11039: The publish permission is denied.

## ◆ CHANNEL_SUBSCRIBE_CANCELED

io.agora.rtm.RtmConstants.RtmErrorCode.CHANNEL_SUBSCRIBE_CANCELED =(-11040)

-11040: The subscribe operation is canceled.

## ◆ STORAGE_OPERATION_FAILED

io.agora.rtm.RtmConstants.RtmErrorCode.STORAGE_OPERATION_FAILED =(-12001)

-12001 ~ -13000 : reserved for storage error. -12001: The storage operation failed.

## ◆ STORAGE_METADATA_ITEM_EXCEED_LIMITATION

io.agora.rtm.RtmConstants.RtmErrorCode.STORAGE_METADATA_ITEM_EXCEED_LIMITATION =(-12002)

-12002: The metadata item count exceeds the limit.

## ◆ STORAGE_INVALID_METADATA_ITEM

io.agora.rtm.RtmConstants.RtmErrorCode.STORAGE_INVALID_METADATA_ITEM =(-12003)

-12003: The metadata item is invalid.

## ◆ STORAGE_INVALID_ARGUMENT

io.agora.rtm.RtmConstants.RtmErrorCode.STORAGE_INVALID_ARGUMENT =(-12004)

-12004: The argument in storage operation is invalid.

## ◆ STORAGE_INVALID_REVISION

io.agora.rtm.RtmConstants.RtmErrorCode.STORAGE_INVALID_REVISION =(-12005)

-12005: The revision in storage operation is invalid.

## ◆ STORAGE_METADATA_LENGTH_OVERFLOW

io.agora.rtm.RtmConstants.RtmErrorCode.STORAGE_METADATA_LENGTH_OVERFLOW =(-12006)

-12006: The metadata length exceeds the limit.

## ◆ STORAGE_INVALID_LOCK_NAME

io.agora.rtm.RtmConstants.RtmErrorCode.STORAGE_INVALID_LOCK_NAME =(-12007)

-12007: The lock name in storage operation is invalid.

## ◆ STORAGE_LOCK_NOT_ACQUIRED

io.agora.rtm.RtmConstants.RtmErrorCode.STORAGE_LOCK_NOT_ACQUIRED =(-12008)

-12008: The lock in storage operation is not acquired.

## ◆ STORAGE_INVALID_KEY

io.agora.rtm.RtmConstants.RtmErrorCode.STORAGE_INVALID_KEY =(-12009)

-12009: The metadata key is invalid.

## ◆ STORAGE_INVALID_VALUE

io.agora.rtm.RtmConstants.RtmErrorCode.STORAGE_INVALID_VALUE =(-12010)

-12010: The metadata value is invalid.

## ◆ STORAGE_KEY_LENGTH_OVERFLOW

io.agora.rtm.RtmConstants.RtmErrorCode.STORAGE_KEY_LENGTH_OVERFLOW =(-12011)

-12011: The metadata key length exceeds the limit.

## ◆ STORAGE_VALUE_LENGTH_OVERFLOW

io.agora.rtm.RtmConstants.RtmErrorCode.STORAGE_VALUE_LENGTH_OVERFLOW =(-12012)

-12012: The metadata value length exceeds the limit.

## ◆ STORAGE_DUPLICATE_KEY

io.agora.rtm.RtmConstants.RtmErrorCode.STORAGE_DUPLICATE_KEY =(-12013)

-12013: The metadata key already exists.

## ◆ STORAGE_OUTDATED_REVISION

io.agora.rtm.RtmConstants.RtmErrorCode.STORAGE_OUTDATED_REVISION =(-12014)

-12014: The revision in storage operation is outdated or the key does not exist.

## ◆ STORAGE_NOT_SUBSCRIBE

io.agora.rtm.RtmConstants.RtmErrorCode.STORAGE_NOT_SUBSCRIBE =(-12015)

-12015: The storage operation performed without subscribing.

## ◆ STORAGE_INVALID_METADATA_INSTANCE

io.agora.rtm.RtmConstants.RtmErrorCode.STORAGE_INVALID_METADATA_INSTANCE =(-12016)

-12016: The metadata item is invalid.

## ◆ STORAGE_SUBSCRIBE_USER_EXCEED_LIMITATION

io.agora.rtm.RtmConstants.RtmErrorCode.STORAGE_SUBSCRIBE_USER_EXCEED_LIMITATION =(-12017)

-12017: The user count exceeds the limit when try to subscribe.

## ◆ STORAGE_OPERATION_TIMEOUT

io.agora.rtm.RtmConstants.RtmErrorCode.STORAGE_OPERATION_TIMEOUT =(-12018)

-12018: The storage operation timeout.

## ◆ STORAGE_NOT_AVAILABLE

io.agora.rtm.RtmConstants.RtmErrorCode.STORAGE_NOT_AVAILABLE =(-12019)

-12019: The storage service not available.

## ◆ STORAGE_PERMISSION_DENIED

io.agora.rtm.RtmConstants.RtmErrorCode.STORAGE_PERMISSION_DENIED =(-12020)

-12020: The storage permission is denied.

## ◆ PRESENCE_NOT_CONNECTED

io.agora.rtm.RtmConstants.RtmErrorCode.PRESENCE_NOT_CONNECTED =(-13001)

-13001 ~ -14000 : reserved for presence error. -13001: The user is not connected.

## ◆ PRESENCE_NOT_WRITABLE

io.agora.rtm.RtmConstants.RtmErrorCode.PRESENCE_NOT_WRITABLE =(-13002)

-13002: The presence is not writable.

## ◆ PRESENCE_INVALID_ARGUMENT

io.agora.rtm.RtmConstants.RtmErrorCode.PRESENCE_INVALID_ARGUMENT =(-13003)

-13003: The argument in presence operation is invalid.

## ◆ PRESENCE_CACHED_TOO_MANY_STATES

io.agora.rtm.RtmConstants.RtmErrorCode.PRESENCE_CACHED_TOO_MANY_STATES =(-13004)

-13004: The cached presence state count exceeds the limit.

## ◆ PRESENCE_STATE_COUNT_OVERFLOW

io.agora.rtm.RtmConstants.RtmErrorCode.PRESENCE_STATE_COUNT_OVERFLOW =(-13005)

-13005: The state count exceeds the limit.

## ◆ PRESENCE_INVALID_STATE_KEY

io.agora.rtm.RtmConstants.RtmErrorCode.PRESENCE_INVALID_STATE_KEY =(-13006)

-13006: The state key is invalid.

## ◆ PRESENCE_INVALID_STATE_VALUE

io.agora.rtm.RtmConstants.RtmErrorCode.PRESENCE_INVALID_STATE_VALUE =(-13007)

-13007: The state value is invalid.

## ◆ PRESENCE_STATE_KEY_SIZE_OVERFLOW

io.agora.rtm.RtmConstants.RtmErrorCode.PRESENCE_STATE_KEY_SIZE_OVERFLOW =(-13008)

-13008: The state key length exceeds the limit.

## ◆ PRESENCE_STATE_VALUE_SIZE_OVERFLOW

io.agora.rtm.RtmConstants.RtmErrorCode.PRESENCE_STATE_VALUE_SIZE_OVERFLOW =(-13009)

-13009: The state value length exceeds the limit.

## ◆ PRESENCE_STATE_DUPLICATE_KEY

io.agora.rtm.RtmConstants.RtmErrorCode.PRESENCE_STATE_DUPLICATE_KEY =(-13010)

-13010: The state key already exists.

## ◆ PRESENCE_USER_NOT_EXIST

io.agora.rtm.RtmConstants.RtmErrorCode.PRESENCE_USER_NOT_EXIST =(-13011)

-13011: The user is not exist.

## ◆ PRESENCE_OPERATION_TIMEOUT

io.agora.rtm.RtmConstants.RtmErrorCode.PRESENCE_OPERATION_TIMEOUT =(-13012)

-13012: The presence operation timeout.

## ◆ PRESENCE_OPERATION_FAILED

io.agora.rtm.RtmConstants.RtmErrorCode.PRESENCE_OPERATION_FAILED =(-13013)

-13013: The presence operation failed.

## ◆ PRESENCE_INACTIVE

io.agora.rtm.RtmConstants.RtmErrorCode.PRESENCE_INACTIVE =(-13014)

-13014: The presence service is not activated.

## ◆ PRESENCE_PENDING_REQUEST_CANCELLED

io.agora.rtm.RtmConstants.RtmErrorCode.PRESENCE_PENDING_REQUEST_CANCELLED =(-13015)

-13015: The presence pending request is cancelled.

## ◆ PRESENCE_PENDING_REQUEST_EXCEED_LIMITATION

io.agora.rtm.RtmConstants.RtmErrorCode.PRESENCE_PENDING_REQUEST_EXCEED_LIMITATION =(-13016)

-13016: The presence pending request count exceeds the limitation.

## ◆ LOCK_OPERATION_FAILED

io.agora.rtm.RtmConstants.RtmErrorCode.LOCK_OPERATION_FAILED =(-14001)

-14001 ~ -15000 : reserved for lock error. -14001: The lock operation failed.

## ◆ LOCK_OPERATION_TIMEOUT

io.agora.rtm.RtmConstants.RtmErrorCode.LOCK_OPERATION_TIMEOUT =(-14002)

-14002: The lock operation timeout.

## ◆ LOCK_OPERATION_PERFORMING

io.agora.rtm.RtmConstants.RtmErrorCode.LOCK_OPERATION_PERFORMING =(-14003)

-14003: The lock operation is performing.

## ◆ LOCK_ALREADY_EXIST

io.agora.rtm.RtmConstants.RtmErrorCode.LOCK_ALREADY_EXIST =(-14004)

-14004: The lock already exists.

## ◆ LOCK_INVALID_NAME

io.agora.rtm.RtmConstants.RtmErrorCode.LOCK_INVALID_NAME =(-14005)

-14005: The lock name is invalid.

## ◆ LOCK_NOT_ACQUIRED

io.agora.rtm.RtmConstants.RtmErrorCode.LOCK_NOT_ACQUIRED =(-14006)

-14006: The lock is not acquired.

## ◆ LOCK_ACQUIRE_FAILED

io.agora.rtm.RtmConstants.RtmErrorCode.LOCK_ACQUIRE_FAILED =(-14007)

-14007: Acquire lock failed.

## ◆ LOCK_NOT_EXIST

io.agora.rtm.RtmConstants.RtmErrorCode.LOCK_NOT_EXIST =(-14008)

-14008: The lock is not exist.

## ◆ LOCK_NOT_AVAILABLE

io.agora.rtm.RtmConstants.RtmErrorCode.LOCK_NOT_AVAILABLE =(-14009)

-14009: The lock service is not available.

## ◆ LOCK_PERMISSION_DENIED

io.agora.rtm.RtmConstants.RtmErrorCode.LOCK_PERMISSION_DENIED =(-14010)

-14010: The lock permission is denied.

## ◆ HISTORY_OPERATION_FAILED

io.agora.rtm.RtmConstants.RtmErrorCode.HISTORY_OPERATION_FAILED =(-15001)

-15001 ~ -16000 : reserved for history error. -15001: The history operation failed.

## ◆ HISTORY_INVALID_TIMESTAMP

io.agora.rtm.RtmConstants.RtmErrorCode.HISTORY_INVALID_TIMESTAMP =(-15002)

-15002: The timestamp is invalid.

## ◆ HISTORY_OPERATION_TIMEOUT

io.agora.rtm.RtmConstants.RtmErrorCode.HISTORY_OPERATION_TIMEOUT =(-15003)

-15003: The history operation timeout.

## ◆ HISTORY_OPERATION_NOT_PERMITTED

io.agora.rtm.RtmConstants.RtmErrorCode.HISTORY_OPERATION_NOT_PERMITTED =(-15004)

-15004: The history operation is not permitted.

## ◆ HISTORY_NOT_AVAILABLE

io.agora.rtm.RtmConstants.RtmErrorCode.HISTORY_NOT_AVAILABLE =(-15005)

-15005: The history service not available.

## ◆ HISTORY_PERMISSION_DENIED

io.agora.rtm.RtmConstants.RtmErrorCode.HISTORY_PERMISSION_DENIED =(-15006)

-15006: The history permission is denied.